*= $0800
.byte $00,$0c,$08,$0a,$00,$9e,$32,$30,$36,$34,$00,$00,$00,$00
*= $0810

	sei

	lda #$1b
	ldx #$09
	sta $d011   ; clear the high bit of $d012 and set text mode
	stx $d016   ; single color

	lda #$7f
	ldx #$01
	sta $dc0d   ; turn off cia 1 interrupts
	sta $dd0d   ; turn off cia 2 interrupts
	stx $d01a   ; turn on raster interrupts

	lda #<int
	ldx #>int
	ldy #$c0
	sta $fffe ; set our interrupt handler to int
	stx $ffff
	sty $d012   ; and the rasterline to #240

	lda #$35 
	sta $01

	lda $dc0d   ; acknowledge cia 1 interrupts
	lda $dd0d   ; acknowledge cia 2 interrupts
	asl $d019   ; enable interrupts
	cli

	ldx #$08    ; some initialisation for putdot
        lda #$01
fillpixtable
        sta $e4,x
        asl a
        dex
        bne fillpixtable

	jsr genbufytable
	jsr genytables

	lda #$07
	sta $d020
	sta $d021
	lda #$00
	jsr setfg

	lda #$00
	jsr $1000

	jsr clearcharset1
	jsr clrscreen

        ldx #$10    ; make us a nice 16x16
        ldy #$00
initmatrix1616
        lda #$00
        sta $0500,y
        inc initmatrix1616+1
        lda #40
        clc
        adc initmatrix1616+3
        bcc *+5
        inc initmatrix1616+4
        sta initmatrix1616+3
        dex
        bne initmatrix1616
        lda #$05
        sta initmatrix1616+4
        lda #$00
        sta initmatrix1616+3
        ldx #$10
        iny
        clc
        cpy #$10
        bne initmatrix1616

radius = $c0
tmp = $c1
bigger = $c2
trigger = $c3

	lda #$01
	sta bigger

	lda #$fe
	sta trigger

	lda #$04
	sta radius

inccircle
	lda #$38
        sta offpd+1

	jsr clearcharset2
	lda radius
	ldx #$40
	ldy #$40
	sta bcircler
	stx bcirclex
	sty bcircley
	jsr bresencircle
	lda radius
	lsr
	sta tmp
	lda #$40
	sec
	sbc tmp
	sta bcircley
	jsr bresensmile
	lda tmp
	lsr
	lsr
	bne *+4
	lda #$01
	sta bcircler
	lda #$40
	sec
	sbc tmp
	sta bcircley
	lsr tmp
	lda #$40
	sec
	sbc tmp
	sta bcirclex
	jsr bresencircle
	lda #$40
	clc
	adc tmp
	sta bcirclex
	jsr bresencircle

waitforit1
        lda $d012
        cmp #$f0
        bne waitforit1

        lda $d018   ; point our charset to $3800
        and #$f1
        ora #$0f
	sta $d018

	jsr clearcharset1
	jsr bigorsmall
	
        lda #$30
        sta offpd+1

        lda radius
        ldx #$40
        ldy #$40
        sta bcircler
        stx bcirclex
        sty bcircley
        jsr bresencircle
        lda radius
        lsr
        sta tmp
        lda #$40
        sec
        sbc tmp
        sta bcircley
        jsr bresensmile
        lda tmp
        lsr
        lsr
        bne *+4
        lda #$01
        sta bcircler
        lda #$40
        sec
        sbc tmp
        sta bcircley
        lsr tmp
        lda #$40
        sec
        sbc tmp
        sta bcirclex
        jsr bresencircle
        lda #$40
        clc
        adc tmp
        sta bcirclex
        jsr bresencircle

waitforit2
	lda $d012
	cmp #$f0
	bne waitforit2

        lda $d018   ; point our charset to $3000
        and #$f1
        ora #$0c 
        sta $d018

	lda trigger
	beq *+5
	jmp inccircle

        ldx #$40
fillsprite
        lda happysprite,x
        sta $200,x
	lda kissingsprite,x
	sta $280,x
        dex
        bpl fillsprite

	ldx #$00
fillspr2
	lda #$ff
	sta $240,x
	inx
	sta $240,x
	inx
	lda #$00
	sta $240,x
	inx
	cpx #$30
	bcc fillspr2

        lda #$08
	ldx #$02
sprpoint
        sta $07f8,x
        sta $23f8,x
	dex
	bpl sprpoint
	lda #$09
	sta $07fb
	sta $23fb
	sta $07fc
	sta $23fc

        lda #$00
        sta $d027
        sta $d028
        sta $d029
	lda #$03
	sta $d02a
	sta $d02b

        ldx #$ce
        ldy #$99
        stx $d000
        sty $d001
	stx $d002
	sty $d003
	stx $d004
	sty $d005

	ldx #$19
	ldy #$c0
	stx $d006
	sty $d007
	ldx #$01
	stx $d008
	sty $d009

	lda #$18
	sta $d010

        lda #$07
        sta $d015

	jsr clrscreen
	jsr clrscreen2

charval = $c5
charbuf = $c6
        lda #$00
        sta charval

gencharset
        lda #$00
        ldx #$08
clrcharbuf
        sta charbuf,x
        dex
        bpl clrcharbuf
        lda charval
        and #$03
        cmp #$00
        bne dnot0
        lda #$00
        ora charbuf+4
        sta charbuf+4
        lda #$00
        ora charbuf+5
        sta charbuf+5
        lda #$00
        ora charbuf+6
        sta charbuf+6
        lda #$00
        ora charbuf+7
        sta charbuf+7
        jmp checkc
dnot0   cmp #$01
        bne dnot1
        lda #$00
        ora charbuf+4
        sta charbuf+4
        lda #$06
        ora charbuf+5
        sta charbuf+5
        lda #$06
        ora charbuf+6
        sta charbuf+6
        lda #$00
        ora charbuf+7
        sta charbuf+7
        jmp checkc
dnot1   cmp #$02
        bne dnot2
        lda #$06
        ora charbuf+4
        sta charbuf+4
        lda #$0f
        ora charbuf+5
        sta charbuf+5
        lda #$0f
        ora charbuf+6
        sta charbuf+6
        lda #$06
        ora charbuf+7
        sta charbuf+7
        jmp checkc
dnot2   lda #$0f
        ora charbuf+4
        sta charbuf+4
        lda #$0f
        ora charbuf+5
        sta charbuf+5
        lda #$0f
        ora charbuf+6
        sta charbuf+6
        lda #$0f
        ora charbuf+7
        sta charbuf+7
checkc
        lda charval
        and #$0c
        lsr
        lsr
        cmp #$00
        bne cnot0
        lda #$00
        ora charbuf+4
        sta charbuf+4
        lda #$00
        ora charbuf+5
        sta charbuf+5
        lda #$00
        ora charbuf+6
        sta charbuf+6
        lda #$00
        ora charbuf+7
        sta charbuf+7
        jmp checkb
cnot0   cmp #$01
        bne cnot1
        lda #$00
        ora charbuf+4
        sta charbuf+4
        lda #$60
        ora charbuf+5
        sta charbuf+5
        lda #$60
        ora charbuf+6
        sta charbuf+6
        lda #$00
        ora charbuf+7
        sta charbuf+7
        jmp checkb
cnot1   cmp #$02
        bne cnot2
        lda #$60
        ora charbuf+4
        sta charbuf+4
        lda #$f0
        ora charbuf+5
        sta charbuf+5
        lda #$f0
        ora charbuf+6
        sta charbuf+6
        lda #$60
        ora charbuf+7
        sta charbuf+7
        jmp checkb
cnot2   lda #$f0
        ora charbuf+4
        sta charbuf+4
        lda #$f0
        ora charbuf+5
        sta charbuf+5
        lda #$f0
        ora charbuf+6
        sta charbuf+6
        lda #$f0
        ora charbuf+7
        sta charbuf+7
checkb  lda charval
        and #$30
        cmp #$00
        bne bnot0
        lda #$00
        ora charbuf
        sta charbuf
        lda #$00
        ora charbuf+1
        sta charbuf+1
        lda #$00
        ora charbuf+2
        sta charbuf+2
        lda #$00
        ora charbuf+3
        sta charbuf+3
        jmp checka
bnot0   cmp #$10
        bne bnot1
        lda #$00
        ora charbuf
        sta charbuf
        lda #$06
        ora charbuf+1
        sta charbuf+1
        lda #$06
        ora charbuf+2
        sta charbuf+2
        lda #$00
        ora charbuf+3
        sta charbuf+3
        jmp checka
bnot1   cmp #$20
        bne bnot2
        lda #$06
        ora charbuf
        sta charbuf
        lda #$0f
        ora charbuf+1
        sta charbuf+1
        lda #$0f
        ora charbuf+2
        sta charbuf+2
        lda #$06
        ora charbuf+3
        sta charbuf+3
        jmp checka
bnot2   lda #$0f
        ora charbuf
        sta charbuf
        lda #$0f
        ora charbuf+1
        sta charbuf+1
        lda #$0f
        ora charbuf+2
        sta charbuf+2
        lda #$0f
        ora charbuf+3
        sta charbuf+3
checka  lda charval
        and #$c0
        lsr
        lsr
        cmp #$00
        bne anot0
        lda #$00
        ora charbuf
        sta charbuf
        lda #$00
        ora charbuf+1
        sta charbuf+1
        lda #$00
        ora charbuf+2
        sta charbuf+2
        lda #$00
        ora charbuf+3
        sta charbuf+3
        jmp checkdone
anot0   cmp #$10
        bne anot1
        lda #$00
        ora charbuf
        sta charbuf
        lda #$60
        ora charbuf+1
        sta charbuf+1
        lda #$60
        ora charbuf+2
        sta charbuf+2
        lda #$00
        ora charbuf+3
        sta charbuf+3
        jmp checkdone
anot1   cmp #$20
        bne anot2
        lda #$60
        ora charbuf
        sta charbuf
        lda #$f0
        ora charbuf+1
        sta charbuf+1
        lda #$f0
        ora charbuf+2
        sta charbuf+2
        lda #$60
        ora charbuf+3
        sta charbuf+3
        jmp checkdone
anot2   lda #$f0
        ora charbuf
        sta charbuf
        lda #$f0
        ora charbuf+1
        sta charbuf+1
        lda #$f0
        ora charbuf+2
        sta charbuf+2
        lda #$f0
        ora charbuf+3
        sta charbuf+3
checkdone

        ldx #$08
pushbuftochar
        lda charbuf,x
coff    sta $3000,x
        dex
        bpl pushbuftochar
        lda coff+1
        clc
        adc #$08
        bcc *+5
        inc coff+2
        sta coff+1
        inc charval
        lda charval
        beq *+5
        jmp gencharset

        lda #$07
        jsr setfg

	lda #$04
	sta ball1R
	lda #$08
	ldy #$00
	sta ball1xa
	sta ball1ya
	sty ballxxa_hi
	sty ballxxa_lo
	sty ballyya_hi
	sty ballyya_lo
	sty ballxxyy_hi
	sty ballxxyy_lo
	sty balltmp
	sty ballsx
	sty ballsy 
	lda #$a0
	sta ballnr
	jsr genballs
	lda #$06
	sta ball1R
	lda #$08
	sta ball1xa
	sta ball1ya
	lda #$a1
	sta ballnr
	jsr genballs
	lda #$03
	sta ball1R
	lda #$08
        sta ball1xa
        sta ball1ya
	lda #$a2
	sta ballnr
	jsr genballs

	jsr clrscreen
	jsr clrbuffer

        lda #$a0
        sta ballnr
        ldx mball1x
        ldy mball1y
        jsr plotball
        lda #$a1
        sta ballnr
        ldx mball2x
        ldy mball2y
        jsr plotball
        lda #$a2
        sta ballnr
        ldx mball3x
        ldy mball3y
        jsr plotball
        jsr cleanballs
        jsr genscreen
        jsr clearballs

        lda #$03
        sta $d020
        sta $d021

spritetopos
	dec $d000
	dec $d000
	dec $d001
	dec $d002
	dec $d002
	dec $d002
	dec $d004
	dec $d004
	inc $d005
	ldy #$1f
idley
	ldx #$7f
idlex
	nop
	dex
	bpl idlex
	dey
	bpl idley
	lda $d000
	cmp #$68
	bne spritetopos

	inc $d002
	inc $d002

        lda #$1f
        sta $d015

	inc showlogo
	jsr plotlogo

loop
	lda #<ytable
	ldx #>ytable
	sta gsoff1+1
	sta gsoff2+1
	sta pcoff1+1
	sta pcoff2+1
	stx gsoff1+2
	stx gsoff2+2
	stx pcoff1+2
	stx pcoff2+2
	lda #$a0
	sta ballnr
	ldx mball1x
	ldy mball1y
	jsr plotball
	lda #$a1
	sta ballnr
	ldx mball2x
	ldy mball2y
	jsr plotball
	lda #$a2
	sta ballnr
	ldx mball3x
	ldy mball3y
	jsr plotball
	jsr cleanballs
	jsr genscreen
	jsr plotlogo
	jsr clearballs
	jsr moveball1
	jsr movesprite1
	jsr moveball2
	jsr movesprite2
	jsr moveball3
	jsr movesprite3
        lda $d018
        and #$0f
        ora #$10
        sta $d018
        lda #<ytable2
        ldx #>ytable2
        sta gsoff1+1
        sta gsoff2+1
        sta pcoff1+1
        sta pcoff2+1
        stx gsoff1+2
        stx gsoff2+2
        stx pcoff1+2
        stx pcoff2+2
	lda #$a0
	sta ballnr
	ldx mball1x
	ldy mball1y
	jsr plotball
        lda #$a1
        sta ballnr
        ldx mball2x
        ldy mball2y
        jsr plotball
        lda #$a2
        sta ballnr
        ldx mball3x
        ldy mball3y
        jsr plotball
	jsr cleanballs
	jsr genscreen
	jsr plotlogo
	jsr clearballs
	jsr moveball1
	jsr movesprite1
	jsr moveball2
	jsr movesprite2
	jsr moveball3
	jsr movesprite3
        lda $d018
        and #$0f
        ora #$80
        sta $d018
jmp loop

int
	pha
	txa
	pha
	tya
	pha	

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	lda showlogo
	beq noshow
	lda #$04
	sta $d020
	sta $d021
	noshow

        lda #<int2
        ldx #>int2
        ldy #$c8
        sta $fffe ; set our interrupt handler to int
        stx $ffff
        sty $d012   ; and the rasterline to #240

	asl $d019

	pla
	tay
	pla
	tax
	pla
	rti

int2
        pha
        txa
        pha
        tya
        pha

        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
	lda showlogo
	beq noshow2
	lda #$03
	sta $d020
	sta $d021

        lda #<int3
        ldx #>int3
        ldy #$10
        sta $fffe ; set our interrupt handler to int
        stx $ffff
        sty $d012   ; and the rasterline to #240

        asl $d019

        pla
        tay
        pla
        tax
        pla
        rti

int3
        pha
        txa
        pha
        tya
        pha

        lda #$0a
        ldx #$02
sprpoint2
        sta $07f8,x
        sta $23f8,x
        dex
        bpl sprpoint2

        lda $d01e
        tax
        and #$01
        bne *+10
        lda #$08
        sta $07f8
        sta $23f8
        txa
        and #$02
        bne *+10
        lda #$08
        sta $07f9
        sta $23f9
        txa
        and #$04
        bne *+10
        lda #$08
        sta $07fa
        sta $23fa

        lda #$ff
        sta $d01e

noshow2

        jsr $1003

        lda #<int
        ldx #>int
        ldy #$c0
        sta $fffe ; set our interrupt handler to int
        stx $ffff
        sty $d012   ; and the rasterline to #240

        asl $d019

        pla
        tay
        pla
        tax
        pla
        rti





; library functions

putc
        tya
        asl
        tay
pcoff1  lda ytable,y
        sta $e0
        iny
pcoff2  lda ytable,y
        sta $e1

        txa
        tay

        lda #$ff
        sta ($e0),y

	lda $e1
	cmp #$09
	bcs toobig
	clc
	adc #$d4
	sta $e1
	lda #$04
	sta ($e0),y
toobig

        rts

addc
	pha
        tya
        asl
        tay
acoff1  lda ytable,y
        sta $e0
        iny
acoff2  lda ytable,y
        sta $e1

        txa
        tay

        pla
	clc
        adc ($e0),y
	cmp #$40
	bcc *+4
	lda #$40
	sta ($e0),y

        rts

plotlogo
        ldy #$04
        ldx #$1d
        jsr putc
        ldy #$04
        ldx #$1e
        jsr putc
        ldy #$18
        ldx #$20
        jsr putc
        ldy #$18
        ldx #$21
        jsr putc

        lda #$04
        sta $c0
pltl1
        ldx #$1c
        ldy $c0
        jsr putc
        ldx #$1f
        ldy $c0
        jsr putc
        inc $c0
        lda $c0
        cmp #$12
        bne pltl1
pltl2
        ldx #$1f
        ldy $c0
        jsr putc
        ldx #$22
        ldy $c0
        jsr putc
        inc $c0
        lda $c0
        cmp #$19
        bne pltl2
        rts

genbufytable
        ldx #$00
genbufy
        lda bufy_lo
        sta bufytable,x
        inx
        lda bufy_hi
        sta bufytable,x
        lda bufy_lo
        clc
        adc #$50
        bcc *+5
        inc bufy_hi
        sta bufy_lo
        inx
        cpx #$80
        bne genbufy
        rts


clrscreen
        ldx #$7f
        lda #$00
clr
        sta $400,x
        sta $480,x
        sta $500,x
        sta $580,x
        sta $600,x
        sta $680,x
        sta $700,x
        dex
        bpl clr
        ldx #$68
clr700
        sta $780,x
        dex
        bpl clr700
        rts

clrscreen2
        ldx #$7f
        lda #$00
clr2
        sta $2000,x
        sta $2080,x
        sta $2100,x
        sta $2180,x
        sta $2200,x
        sta $2280,x
        sta $2300,x
        dex
        bpl clr2
        ldx #$68
clr2300
        sta $2380,x
        dex
        bpl clr2300
        rts

movesprite1
        lda mball1x
        asl
        asl
        clc
        adc #$32
        ldx sprite1right
        beq *+5
        sec
        sbc #$08
        sta $d000
        lda ball1right
        sta sprite1right
        rts

; You can change these for whatever system you're working on.
mul_factor_a   = $e1
mul_factor_x   = $e2
mul_product_lo = $e3
mul_product_hi = $e4

;
; mul
; Wicked fast LUT-based multiplication
; input: a = factor a; x = factor b
; output: mul_factor_a = factor a; mul_factor_x = x = factor x;
;         mul_product_lo = low byte of product a*b;
;         mul_product_hi = a = high byte of product
; preserved: x, y
; max cycles: under 90
;
mul
  sta mul_factor_a      ; setup: 6 cycles
  stx mul_factor_x

  clc                   ; (a + x)^2/2: 23 cycles
  adc mul_factor_x
  tax
  bcc mul_abislo
  lda mul_hibyte512,x
  bcs mul_abishi
mul_abislo
  lda mul_hibyte256,x
  sec
mul_abishi
  sta mul_product_hi
  lda mul_lobyte256,x

  ldx mul_factor_a      ; - a^2/2: 20 cycles
  sbc mul_lobyte256,x
  sta mul_product_lo
  lda mul_product_hi
  sbc mul_hibyte256,x
  sta mul_product_hi

  ldx mul_factor_x      ; + x & a & 1: 22 cycles
  txa                   ; (this is a kludge to correct a
  and mul_factor_a      ; roundoff error that makes odd * odd too low)
  and #1

  clc
  adc mul_product_lo
  bcc mul_nohi
  inc mul_product_hi
mul_nohi
  sec                   ; - x^2/2: 25 cycles
  sbc mul_lobyte256,x
  sta mul_product_lo
  lda mul_product_hi
  sbc mul_hibyte256,x
  sta mul_product_hi
  rts

* = $1000
.binary "happyhardcore.prg",2

movesprite2
        lda mball2y
        asl
        asl
        clc
        adc #$4e
        ldx sprite2down
        beq *+5
        sec
        sbc #$08
        sta $d003
        lda ball2down
        sta sprite2down
        rts

movesprite3
        lda mball3y
        asl
        asl
        clc
        adc #$4e
        ldx sprite3down
        beq *+5
        clc
        sbc #$08
        sta $d005
        lda mball3x
        asl
        asl
        clc
        adc #$32
        ldx sprite3rightup
        beq *+5
        sec
        sbc #$08
        ldx sprite3down
        beq *+5
        sec
        sbc #$04
        sta $d004
        lda ball3rightup
        sta sprite3rightup
        lda ball3down
        sta sprite3down
        rts

; here are the big fat lookup tables
mul_lobyte256
.byte   0,  1,  2,  5,  8, 13, 18, 25, 32, 41, 50, 61, 72, 85, 98,113
.byte 128,145,162,181,200,221,242,  9, 32, 57, 82,109,136,165,194,225
.byte   0, 33, 66,101,136,173,210,249, 32, 73,114,157,200,245, 34, 81
.byte 128,177,226, 21, 72,125,178,233, 32, 89,146,205,  8, 69,130,193
.byte   0, 65,130,197,  8, 77,146,217, 32,105,178,253, 72,149,226, 49
.byte 128,209, 34,117,200, 29,114,201, 32,121,210, 45,136,229, 66,161
.byte   0, 97,194, 37,136,237, 82,185, 32,137,242, 93,200, 53,162, 17
.byte 128,241, 98,213, 72,189, 50,169, 32,153, 18,141,  8,133,  2,129
.byte   0,129,  2,133,  8,141, 18,153, 32,169, 50,189, 72,213, 98,241
.byte 128, 17,162, 53,200, 93,242,137, 32,185, 82,237,136, 37,194, 97
.byte   0,161, 66,229,136, 45,210,121, 32,201,114, 29,200,117, 34,209
.byte 128, 49,226,149, 72,253,178,105, 32,217,146, 77,  8,197,130, 65
.byte   0,193,130, 69,  8,205,146, 89, 32,233,178,125, 72, 21,226,177
.byte 128, 81, 34,245,200,157,114, 73, 32,249,210,173,136,101, 66, 33
.byte   0,225,194,165,136,109, 82, 57, 32,  9,242,221,200,181,162,145
.byte 128,113, 98, 85, 72, 61, 50, 41, 32, 25, 18, 13,  8,  5,  2,  1
mul_hibyte256
.byte   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
.byte   0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1,  1
.byte   2,  2,  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  4,  4
.byte   4,  4,  4,  5,  5,  5,  5,  5,  6,  6,  6,  6,  7,  7,  7,  7
.byte   8,  8,  8,  8,  9,  9,  9,  9, 10, 10, 10, 10, 11, 11, 11, 12
.byte  12, 12, 13, 13, 13, 14, 14, 14, 15, 15, 15, 16, 16, 16, 17, 17
.byte  18, 18, 18, 19, 19, 19, 20, 20, 21, 21, 21, 22, 22, 23, 23, 24
.byte  24, 24, 25, 25, 26, 26, 27, 27, 28, 28, 29, 29, 30, 30, 31, 31
.byte  32, 32, 33, 33, 34, 34, 35, 35, 36, 36, 37, 37, 38, 38, 39, 39
.byte  40, 41, 41, 42, 42, 43, 43, 44, 45, 45, 46, 46, 47, 48, 48, 49
.byte  50, 50, 51, 51, 52, 53, 53, 54, 55, 55, 56, 57, 57, 58, 59, 59
.byte  60, 61, 61, 62, 63, 63, 64, 65, 66, 66, 67, 68, 69, 69, 70, 71
.byte  72, 72, 73, 74, 75, 75, 76, 77, 78, 78, 79, 80, 81, 82, 82, 83
.byte  84, 85, 86, 86, 87, 88, 89, 90, 91, 91, 92, 93, 94, 95, 96, 97
.byte  98, 98, 99,100,101,102,103,104,105,106,106,107,108,109,110,111
.byte 112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127
mul_hibyte512
.byte 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
.byte 144,145,146,147,148,149,150,152,153,154,155,156,157,158,159,160
.byte 162,163,164,165,166,167,168,169,171,172,173,174,175,176,178,179
.byte 180,181,182,184,185,186,187,188,190,191,192,193,195,196,197,198
.byte 200,201,202,203,205,206,207,208,210,211,212,213,215,216,217,219
.byte 220,221,223,224,225,227,228,229,231,232,233,235,236,237,239,240
.byte 242,243,244,246,247,248,250,251,253,254,255,  1,  2,  4,  5,  7
.byte   8,  9, 11, 12, 14, 15, 17, 18, 20, 21, 23, 24, 26, 27, 29, 30
.byte  32, 33, 35, 36, 38, 39, 41, 42, 44, 45, 47, 48, 50, 51, 53, 54
.byte  56, 58, 59, 61, 62, 64, 65, 67, 69, 70, 72, 73, 75, 77, 78, 80
.byte  82, 83, 85, 86, 88, 90, 91, 93, 95, 96, 98,100,101,103,105,106
.byte 108,110,111,113,115,116,118,120,122,123,125,127,129,130,132,134
.byte 136,137,139,141,143,144,146,148,150,151,153,155,157,159,160,162
.byte 164,166,168,169,171,173,175,177,179,180,182,184,186,188,190,192
.byte 194,195,197,199,201,203,205,207,209,211,212,214,216,218,220,222
.byte 224,226,228,230,232,234,236,238,240,242,244,246,248,250,252,254

;Inputs:
;    divhi = bits 15 to 8 of the numerator
;    divlo = bits 7 to 0 of the numerator
;    divby = 8-bit denominator
;
;Outputs:
;    divres = 8-bit quotient of T / B

divhi = $d7
divlo = $d6
divby = $d5
divres = divlo

divide
   	lda divhi
   	ldx #$08
   	asl divlo
div1
	rol
   	bcs div2
   	cmp divby
   	bcc div3
div2 
	sbc divby
   	sec
div3 
	rol divlo
   	dex
   	bne div1
	rts

ball1xa = $d0
ball1ya = $d1
ball1R = $d2
ballxxa_hi = $d3
ballxxa_lo = $d4
ballyya_hi = $d5
ballyya_lo = $d6
ballxxyy_hi = $d7
ballxxyy_lo = $d8
balltmp = $d9
ballsx	= $da
ballsy	= $db

ball2xa = $dc
ball2ya = $dd
ball2r = $de

ballnr .byte $1
sprite3rightup .byte 1
ball3rightup .byte 1
bufy_hi .byte $c0
bufy_lo .byte $00
sprite3down .byte 0
sprite2down .byte 0
sprite1right .byte 0
ball1right .byte 0
ball2down .byte 0
ball3leftup .byte 0
ball3down .byte 0
showlogo .byte 0

moveball1
	lda ball1right
	beq goingleft
	inc mball1x
	lda mball1x
	cmp #$1c
	bne *+5
	dec ball1right
	rts
goingleft
	dec mball1x
	lda mball1x
	cmp #$02
	bne *+5
	inc ball1right
	rts

moveball2
        lda ball2down
        beq goingup
        inc mball2y
        lda mball2y
        cmp #$18
        bne *+5
        dec ball2down
        rts
goingup
        dec mball2y
        lda mball2y
        cmp #$02
        bne *+5
        inc ball2down
        rts

moveball3
	lda ball3rightup
	beq notrightup
	inc mball3x
	dec mball3y
	lda mball3x
	cmp #$1b
	bne *+8
	dec ball3rightup
	inc ball3leftup
	rts
notrightup
	lda ball3leftup
	beq notleftup
	dec mball3x
	dec mball3y
	lda mball3x
	cmp #$0a
	bne *+8
	dec ball3leftup
	inc ball3down
	rts
notleftup
	inc mball3y
	lda mball3y
	cmp #$22
	bne *+8
	dec ball3down
	inc ball3rightup
	rts

genballs
        lda ballsx
        tax
        sec
        sbc ball1xa
        bpl gbxxanotneg
        stx balltmp
        lda ball1xa
        sec
        sbc balltmp
gbxxanotneg
        cmp #$09
        bcs gbxxtoobig
        tax
        jsr mul
        lda mul_product_lo
        sta ballxxa_lo
gbballsovery
        lda ballsy
        tay
        sec
        sbc ball1ya
        bpl gbyyanotneg
        sty balltmp
        lda ball1ya
        sec
        sbc balltmp
gbyyanotneg
        cmp #$09
        bcs gbxxyytoobig
        tax
        jsr mul
        lda mul_product_lo
        sta ballxxyy_lo
        clc
        adc ballxxa_lo
        bcc *+5
        jmp gbxxyytoobig
        sta ballxxyy_lo
        bne *+7
        lda #$40
        jmp gbballsdivbyzero
        sta divby
        lda ball1R
        sta divhi
        lda #$00
        sta divlo
        jsr divide
        lda divres
gbballsdivbyzero
        ldx ballsx
        ldy ballsy
        jsr putballdot
        jmp gbweredone
gbxxyytoobig
gbweredone
        inc ballsy
        lda ballsy
        cmp #$0f
        bne gbballsovery
gbxxtoobig
        lda #$00
        sta ballsy
        inc ballsx
        lda ballsx
        cmp #$10
        bne genballs
        lda #$00
        sta ballsx
        rts

putballdot
	pha
	tya
	asl
	asl
	asl
	asl
	sta bbufoff+1
	lda ballnr
	sta bbufoff+2
	pla
	asl
	bcc *+4
	lda #$ff
bbufoff	sta $100,x	
	rts

plotball
	tya
        asl
        tay
pboff1  lda bufytable,y
        sta pboff3+1
        sta pboff5+1
        iny
pboff2  lda bufytable,y
        sta pboff3+2
        sta pboff5+2
	txa
	clc
	adc pboff3+1
	bcc *+8
	inc pboff3+2
	inc pboff5+2
	sta pboff3+1
	sta pboff5+1
	ldy #$00
pbovery
	tya
        asl
        asl
        asl
        asl
	sta pboff4+1
	lda ballnr
	sta pboff4+2
	ldx #$0f
pboverx
pboff3  lda $400,x
	clc
pboff4  adc $100,x
	bcc *+4
	lda #$ff
pboff5  sta $400,x
	dex
	bpl pboverx
	lda pboff3+1
	clc
	adc #80
	bcc *+8
	inc pboff3+2
	inc pboff5+2
	sta pboff3+1
	sta pboff5+1
	iny
pbyoff	cpy #$0f
	bne pbovery
	rts

mball1x .byte $0e
mball1y .byte $07
mball2x .byte $02
mball2y .byte $14
mball3x .byte $0e
mball3y .byte $20

clrbuffer
	lda #$00
	ldx #$7f
clrbuf
	sta $c000,x
	sta $c080,x
	sta $c100,x
	sta $c180,x
	sta $c200,x
	sta $c280,x
	sta $c300,x
	sta $c380,x
	sta $c400,x
	sta $c480,x
	sta $c500,x
	sta $c580,x
	sta $c600,x
	sta $c680,x
	sta $c700,x
	sta $c780,x
	sta $c800,x
	sta $c880,x
	sta $c900,x
	sta $c980,x
	sta $ca00,x
	sta $ca80,x
	sta $cb00,x
	sta $cb80,x
	sta $cc00,x
	sta $cc80,x
	sta $cd00,x
	sta $cd80,x
	sta $ce00,x
	sta $ce80,x
	sta $cf00,x
	sta $cf80,x
	dex
	bpl clrbuf
	rts

genscreen
gby1	ldy #$00
gby2	lda #$00
gsovery
	lsr
	tax
gsoff1	lda ytable,x
	sta scry1+1
	sta scry2+1
	sta scry3+1
	sta scry4+1
	sta scry5+1
	sta scry6+1
	sta scry7+1
	inx
gsoff2  lda ytable,x
        sta scry1+2
        sta scry2+2
        sta scry3+2
        sta scry4+2
        sta scry5+2
        sta scry6+2
        sta scry7+2
	lda bufytable,y
	sta bufy1+1
	sta bufy3+1
	iny
	lda bufytable,y
	sta bufy1+2
	sta bufy3+2
	iny
	lda bufytable,y
	sta bufy2+1
	sta bufy4+1
	iny
	lda bufytable,y
	sta bufy2+2
	sta bufy4+2
	iny
	tya
	pha
gbx1	ldx #$2b
oneline
bufy1	lda $c000,x
	and #$c0
	lsr
	lsr
	pha
	txa
	lsr
	tay
	pla
scry1	sta $400,y
bufy2	lda $c050,x
	and #$c0
	lsr
	lsr
	lsr
	lsr
	lsr
	lsr
scry2   ora $400,y
scry3   sta $400,y
	dex
bufy3	lda $c000,x
	and #$c0
scry4	ora $400,y
scry5	sta $400,y
bufy4	lda $c050,x
	and #$c0
	lsr
	lsr
	lsr
	lsr
scry6	ora $400,y
scry7   sta $400,y
	dex
	bpl oneline
	pla
	tay
gby3	cmp #$60
	bcs *+5
	jmp gsovery
	rts

cleanballs
	lda #<mball1y
	ldx #>mball1y
	sta cby+1
	stx cby+2
        lda #<mball1x
        ldx #>mball1x
        sta cbx1+1
        stx cbx1+2
	jsr cbloop
        lda #<mball2y
        ldx #>mball2y
        sta cby+1
        stx cby+2
        lda #<mball2x
        ldx #>mball2x
        sta cbx1+1
        stx cbx1+2
        jsr cbloop
        lda #<mball3y
        ldx #>mball3y
        sta cby+1
        stx cby+2
        lda #<mball3x
        ldx #>mball3x
        sta cbx1+1
        stx cbx1+2
        jsr cbloop
	rts

cbloop
cby	lda mball1y
	asl
	tay
	clc
	adc #$1e
	sta cbcmpy+1
cb1loopy
	lda bufytable,y
	sta cboff1+1
	sta cboff2+1
	iny
	lda bufytable,y
	sta cboff1+2
	sta cboff2+2
	iny
cbx1	lda mball1x
	tax
	clc
	adc #$10
	sta cbcmpx+1
cb1loopx
cboff1	lda $c000,x
	cmp #$70
	bcs *+7
	lda #$00
cboff2	sta $c000,x
	inx
cbcmpx	cpx #$0f
	bne cb1loopx
cbcmpy	cpy #$0f
	bne cb1loopy
	rts	

clearballs
        ldy #<mball1y
        ldx #>mball1y
        sty clby+1
        stx clby+2
        ldy #<mball1x
        ldx #>mball1x
        sty clbx1+1
        stx clbx1+2
        jsr clbloop
        ldy #<mball2y
        ldx #>mball2y
        sty clby+1
        stx clby+2
        ldy #<mball2x
        ldx #>mball2x
        sty clbx1+1
        stx clbx1+2
        jsr clbloop
        ldy #<mball3y
        ldx #>mball3y
        sty clby+1
        stx clby+2
        ldy #<mball3x
        ldx #>mball3x
        sty clbx1+1
        stx clbx1+2
        jsr clbloop
        rts

clbloop
clby    lda mball1y
        asl
        tay
        clc
        adc #$22
        sta clbcmpy+1
clb1loopy
        lda bufytable,y
        sta clboff1+1
        iny
        lda bufytable,y
        sta clboff1+2
        iny
clbx1   lda mball1x
	tax
        clc
        adc #$12
        sta clbcmpx+1
clb1loopx
	lda #$00
clboff1 sta $c000,x
        inx
clbcmpx cpx #$0f
        bne clb1loopx
clbcmpy cpy #$0f
        bne clb1loopy
        rts

setfg
        ldx #$7f
setfgloop
        sta $d800,x
        sta $d880,x
        sta $d900,x
        sta $d980,x
        sta $da00,x
        sta $da80,x
        sta $db00,x
        dex
	bpl setfgloop
        ldx #$67
setfglast
        sta $db80,x
        dex
        bpl setfglast
        rts

happysprite
        .byte $00,$7e,$00
        .byte $01,$81,$80
        .byte $06,$00,$60
        .byte $08,$00,$10
        .byte $08,$66,$10
        .byte $10,$99,$08
        .byte $10,$66,$08
        .byte $20,$00,$04
        .byte $20,$00,$04
        .byte $20,$00,$04
        .byte $20,$00,$04
        .byte $20,$00,$04
        .byte $16,$00,$68
        .byte $11,$81,$88
        .byte $08,$7e,$10
        .byte $08,$00,$10
        .byte $06,$00,$60
        .byte $01,$81,$80
        .byte $00,$7e,$00
        .byte $00,$00,$00
        .byte $00,$00,$00
        .byte 0

kissingsprite
        .byte $00,$7e,$00
        .byte $01,$81,$80
        .byte $06,$00,$60
        .byte $08,$00,$10
        .byte $08,$66,$10
        .byte $10,$99,$08
        .byte $10,$66,$08
        .byte $20,$00,$04
        .byte $20,$00,$04
        .byte $20,$00,$04
        .byte $20,$42,$04
        .byte $20,$24,$04
        .byte $16,$18,$68
        .byte $10,$24,$08
        .byte $08,$42,$10
        .byte $08,$00,$10
        .byte $06,$00,$60
        .byte $01,$81,$80
        .byte $00,$7e,$00
        .byte $00,$00,$00
        .byte $00,$00,$00
        .byte 0

bcirclex = $e0
bcircley = $e1
bcircler = $df

bresencircle
        ; cx = f0 , cy = f1 , radius = ef , error = ee , x = ec , y = ed
        lda #$00
        ldx $df
        sta $dd ; int y = 0;
        sbc $df
        sta $de ; int error = -radius;
        stx $dc ; int y = 0;
bcloop
        jsr plot8points
        lda $de
        adc $dd ; error += y;
        inc $dd ; ++y;
        adc $dd
        sta $de ; error += y;
        cmp #$80        ; if (error >= 0)
        bcs skipbc
        sbc $dc ; error -= x;
        dec $dc ; --x;
        sbc $dc
        sta $de ; error -= x;
skipbc
        lda $dc ; while (x >= y)
        cmp $dd
        bcs bcloop
        rts

plot8points
        ldx $dc
        ldy $dd
        stx $da
        sty $db
        jsr plot4points ; up and down
        lda $dc
        cmp $dd
        beq bcnosym
        ldx $dc
        ldy $dd
        stx $db
        sty $da
        jsr plot4points ; left and right
bcnosym rts

plot4points
        ; cx = f0 , cy = f1 , radius = ef , error = ee , x = ea , y = eb
        lda $e0
        adc $da
        tax
        lda $e1
        adc $db
        tay
        tya
        cmp $e1
        bne *+3
        inx
        jsr putdot      ; setPixel(cx + x, cy + y); rightunder
        lda $e0
        sbc $da
        tax
        lda $e1
	clc
        adc $db
        tay
        jsr putdot      ; setPixel(cx - x, cy + y);
xis0
        lda $db
        cmp #$00
        beq yis0        ; if (y != 0)
        lda $e0
        adc $da
        tax
        lda $e1
	sec
        sbc $db
        tay
        jsr putdot      ; setPixel(cx + x, cy - y);
yis0
        lda $e0
        sbc $da
        tax
        lda $e1
	sec
        sbc $db
        tay
        jsr putdot      ; setPixel(cx - x, cy - y);
        rts

putdot          ; takes x, y, uses f5 - ff, preserves y
        txa
        and #$f8
        sta $ed
        lsr a
        lsr a
        lsr a
        lsr a
        clc
offpd   adc #$30
        sta $ef
        txa
        and #$08
        beq *+4
        lda #$80
        sta $ee
        txa
        sec
        sbc $ed
        tax
        lda $e5,x
        ora ($ee),y
        sta ($ee),y
        rts

clearcharset1
	lda #$00
	ldx #$7f
clrchr1
	sta $3000,x
	sta $3080,x
	sta $3100,x
	sta $3180,x
	sta $3200,x
	sta $3280,x
	sta $3300,x
	sta $3380,x
	sta $3400,x
	sta $3480,x
	sta $3500,x
	sta $3580,x
	sta $3600,x
	sta $3680,x
	sta $3700,x
	sta $3780,x
	dex
	bpl clrchr1
	rts

clearcharset2
        lda #$00
        ldx #$7f
clrchr2
        sta $3800,x
        sta $3880,x
        sta $3900,x
        sta $3980,x
        sta $3a00,x
        sta $3a80,x
        sta $3b00,x
        sta $3b80,x
        sta $3c00,x
        sta $3c80,x
        sta $3d00,x
        sta $3d80,x
        sta $3e00,x
        sta $3e80,x
        sta $3f00,x
        sta $3f80,x
        dex
        bpl clrchr2
        rts

bigorsmall
;	lda radius
;	cmp #$1d
;	bne *+5
;	jmp *
        lda bigger
        beq smaller
        inc radius
        lda radius
        cmp #$35
        bne *+4
        dec bigger
        rts
smaller
	dec radius
	lda radius
	cmp #$04
	bne nothappy
	ldx #<smileup
	ldy #>smileup
	stx smileoff+1
	sty smileoff+2
	inc bigger
	inc trigger
nothappy
	lda trigger
	cmp #$ff
	beq *+3
	rts
	lda radius
	cmp #$09
	bne *+5
	inc trigger
	rts

bresensmile
        lda #$00
        ldx $df
        sta $dd 
        sbc $df
        sta $de 
        stx $dc
bsloop
        jsr smile8points
        lda $de
        adc $dd 
        inc $dd
        adc $dd
        sta $de
        cmp #$80
        bcs skipbs
        sbc $dc 
        dec $dc
        sbc $dc
        sta $de
skipbs
        lda $dc 
        cmp $dd
        bcs bsloop
        rts

smile8points
        lda $dc
        cmp $dd
        beq bsnosym
        ldx $dc
        ldy $dd
        stx $db
        sty $da
smileoff
        jsr smiledown
bsnosym rts

smileup
        lda $e0
        adc $da
        tax
        lda $e1
        adc $db
        tay
        tya
        cmp $e1
        bne *+3
        inx
        jsr putdot
        lda $e0
        sbc $da
        tax
        lda $e1
        adc $db
        tay
        dey
        jsr putdot
	rts

smiledown
        lda $db
        cmp #$00
        beq syis0        ; if (y != 0)
        lda $e0
        adc $da
        tax
        lda $e1
        sbc $db
	adc bcircler
	adc tmp
        tay
        iny
        jsr putdot      ; setPixel(cx + x, cy - y);
syis0
        lda $e0
        sbc $da
        tax
        lda $e1
        sbc $db
	adc bcircler
	adc tmp
        tay
        jsr putdot      ; setPixel(cx - x, cy - y);
        rts

genytables
	ldx #$00
	ldy #$04
	stx bufy_lo
	sty bufy_hi
genytab
        lda bufy_lo
        sta ytable,x
        sta ytable2,x
        inx
        lda bufy_hi
        sta ytable,x
	clc
	adc #$1c
	sta ytable2,x
        lda bufy_lo
        clc
        adc #$28
        bcc *+5
        inc bufy_hi
        sta bufy_lo
        inx
        cpx #$80
        bne genytab
        rts


;*=$4000
;.binary "happyhardcore-4000.prg",2
bufytable = $6000
ytable = $6100
ytable2 = $6200
